searchData={"items":[{"type":"module","title":"erldns","doc":"Convenience API to start erldns directly.","ref":"erldns.html"},{"type":"type","title":"erldns.keyset/0","doc":"","ref":"erldns.html#t:keyset/0"},{"type":"function","title":"erldns.start/0","doc":"","ref":"erldns.html#start/0"},{"type":"type","title":"erldns.zone/0","doc":"","ref":"erldns.html#t:zone/0"},{"type":"module","title":"erldns_admin","doc":"Erldns admin API.","ref":"erldns_admin.html"},{"type":"module","title":"Configuration: - erldns_admin","doc":"This application will read from your `sys.config` the following example:\n```erlang\n{erldns, [\n    {admin, [\n        {credentials, {<<\"username\">>, <<\"password\">>}},\n        {port, 8083},\n        {middleware, [my_custom_middleware, another_middleware]}\n    ]}\n]}\n```\nwhere `credentials` is a tuple of `username` and `password` as either strings or binaries,\n`port` is a valid Unix port to listen on, and `middleware` is an optional list of\nmiddleware modules that will be applied to all admin API requests.","ref":"erldns_admin.html#module-configuration"},{"type":"type","title":"erldns_admin.config/0","doc":"Configuration parameters, see the module documentation for details.","ref":"erldns_admin.html#t:config/0"},{"type":"opaque","title":"erldns_admin.handler_state/0","doc":"Common state for all handlers","ref":"erldns_admin.html#t:handler_state/0"},{"type":"function","title":"erldns_admin.maybe_start/0","doc":"","ref":"erldns_admin.html#maybe_start/0"},{"type":"module","title":"erldns_config","doc":"Provide application-wide configuration access.","ref":"erldns_config.html"},{"type":"function","title":"erldns_config.ingress_tcp_request_timeout/0","doc":"Timeout in milliseconds before which a TCP request must be completed.","ref":"erldns_config.html#ingress_tcp_request_timeout/0"},{"type":"function","title":"erldns_config.ingress_udp_request_timeout/0","doc":"Timeout in milliseconds before which an UDP request must be completed.","ref":"erldns_config.html#ingress_udp_request_timeout/0"},{"type":"function","title":"erldns_config.use_root_hints/0","doc":"Use IANA DNS root servers as hints","ref":"erldns_config.html#use_root_hints/0"},{"type":"module","title":"erldns_dnssec","doc":"DNSSEC implementation.","ref":"erldns_dnssec.html"},{"type":"function","title":"erldns_dnssec.get_signed_records/1","doc":"Get signed records from a zone","ref":"erldns_dnssec.html#get_signed_records/1"},{"type":"function","title":"erldns_dnssec.get_signed_zone_records/1","doc":"Get signed records from a zone","ref":"erldns_dnssec.html#get_signed_zone_records/1"},{"type":"function","title":"erldns_dnssec.handle/4","doc":"Apply DNSSEC records to the given message if the zone is signed and DNSSEC is requested.","ref":"erldns_dnssec.html#handle/4"},{"type":"function","title":"erldns_dnssec.map_nsec_rr_types/1","doc":"","ref":"erldns_dnssec.html#map_nsec_rr_types/1"},{"type":"function","title":"erldns_dnssec.map_nsec_rr_types/2","doc":"","ref":"erldns_dnssec.html#map_nsec_rr_types/2"},{"type":"function","title":"erldns_dnssec.maybe_sign_rrset/3","doc":"This function will potentially sign the given RR set if the following conditions are true:\n\n- DNSSEC is requested\n- The zone is signed","ref":"erldns_dnssec.html#maybe_sign_rrset/3"},{"type":"function","title":"erldns_dnssec.rrsig_for_zone_rrset/2","doc":"Given a zone and a set of records, return the RRSIG records.","ref":"erldns_dnssec.html#rrsig_for_zone_rrset/2"},{"type":"module","title":"erldns_handler","doc":"The module that handles the resolution of a single DNS question.\n\nThe meat of the resolution occurs in erldns_resolver:resolve/3","ref":"erldns_handler.html"},{"type":"function","title":"erldns_handler.get_versioned_handlers/0","doc":"Get all registered handlers along with the DNS types they handle and associated versions","ref":"erldns_handler.html#get_versioned_handlers/0"},{"type":"type","title":"erldns_handler.handler/0","doc":"","ref":"erldns_handler.html#t:handler/0"},{"type":"function","title":"erldns_handler.register_handler/2","doc":"Register a record handler with the default version of 1","ref":"erldns_handler.html#register_handler/2"},{"type":"function","title":"erldns_handler.register_handler/3","doc":"Register a record handler with version","ref":"erldns_handler.html#register_handler/3"},{"type":"function","title":"erldns_handler.start_link/0","doc":"Start the handler registry process","ref":"erldns_handler.html#start_link/0"},{"type":"opaque","title":"erldns_handler.state/0","doc":"","ref":"erldns_handler.html#t:state/0"},{"type":"type","title":"erldns_handler.versioned_handler/0","doc":"","ref":"erldns_handler.html#t:versioned_handler/0"},{"type":"module","title":"erldns_proto_udp_acceptor_sup","doc":"","ref":"erldns_proto_udp_acceptor_sup.html"},{"type":"function","title":"erldns_proto_udp_acceptor_sup.init/1","doc":"","ref":"erldns_proto_udp_acceptor_sup.html#init/1"},{"type":"function","title":"erldns_proto_udp_acceptor_sup.start_link/4","doc":"","ref":"erldns_proto_udp_acceptor_sup.html#start_link/4"},{"type":"module","title":"erldns_axfr","doc":"Implementation of AXFR with IP address whitelisting required.","ref":"erldns_axfr.html"},{"type":"module","title":"AXFR Support - erldns_axfr","doc":"AXFR zone transfers are not currently implemented. The current \"implementation\" is just a stub.","ref":"erldns_axfr.html#module-axfr-support"},{"type":"function","title":"erldns_axfr.call/2","doc":"","ref":"erldns_axfr.html#call/2"},{"type":"function","title":"erldns_axfr.is_enabled/2","doc":"","ref":"erldns_axfr.html#is_enabled/2"},{"type":"module","title":"erldns_empty_verification","doc":"Raise an event if the given message is empty or refused.\n\nMay emit the following telemetry events:\n- `[erldns, pipeline, refused]`, with measurements `#{count => 1}`\n- `[erldns, pipeline, empty]`, with measurements `#{count => 1}`","ref":"erldns_empty_verification.html"},{"type":"function","title":"erldns_empty_verification.call/2","doc":"`c:erldns_pipeline:call/2` callback.","ref":"erldns_empty_verification.html#call/2"},{"type":"module","title":"erldns_packet_cache","doc":"A basic packet cache that is used to avoid multiple lookups for the\nsame question received within the cache TTL.\n\nIn order to work correctly, it should be added to the packet pipeline twice,\nonce early in the processing pipeline, and once _after_ the resolver.","ref":"erldns_packet_cache.html"},{"type":"module","title":"Configuration - erldns_packet_cache","doc":"```erlang\n{erldns, [\n    {packet_cache, #{\n        enabled => boolean(), %% defaults to true\n        ttl => non_neg_integer(), %% Seconds, defaults to 30\n    }}\n]}\n```","ref":"erldns_packet_cache.html#module-configuration"},{"type":"module","title":"Telemetry events - erldns_packet_cache","doc":"- `[erldns, pipeline, cache]` spans as triggered by `m:segmented_cache`.","ref":"erldns_packet_cache.html#module-telemetry-events"},{"type":"function","title":"erldns_packet_cache.call/2","doc":"`c:erldns_pipeline:call/2` callback.","ref":"erldns_packet_cache.html#call/2"},{"type":"function","title":"erldns_packet_cache.clear/0","doc":"Clear the cache","ref":"erldns_packet_cache.html#clear/0"},{"type":"function","title":"erldns_packet_cache.prepare/1","doc":"`c:erldns_pipeline:prepare/1` callback.","ref":"erldns_packet_cache.html#prepare/1"},{"type":"behaviour","title":"erldns_pipeline","doc":"The pipeline specification.\n\nIt declares a pipeline of sequential transformations to apply to the\nincoming query until a response is constructed.\n\nThis module is responsible for handling the pipeline of pipes that will be\nexecuted when a DNS message is received. Handlers in this pipeline will be\nexecuted sequentially, accumulating the result of each handler and passing\nit to the next. This designs a pluggable framework where new behaviour can\nbe injected as a new pipe handler in the right order.","ref":"erldns_pipeline.html"},{"type":"behaviour","title":"Default pipes - erldns_pipeline","doc":"The following are enabled by default, see their documentation for details:\n\n- `m:erldns_query_throttle`\n- `m:erldns_packet_cache`\n- `m:erldns_resolver`\n- `m:erldns_empty_verification`","ref":"erldns_pipeline.html#module-default-pipes"},{"type":"behaviour","title":"Types of pipelines - erldns_pipeline","doc":"There are two kind of pipes: function pipes and module pipes.","ref":"erldns_pipeline.html#module-types-of-pipelines"},{"type":"behaviour","title":"Function pipes - erldns_pipeline","doc":"A function pipe is by definition any function that receives a `t:dns:message/0`\nand a set of options and returns a `t:dns:message/0`. Function pipes must have\nthe following type signature:\n\n```erlang\n-type pipe() :: fun((dns:message(), opts()) -> return()\n```","ref":"erldns_pipeline.html#module-function-pipes"},{"type":"behaviour","title":"Module pipes - erldns_pipeline","doc":"The preferred mechanism, a module pipe is an extension of the function pipe.\n\nIt is a module that exports:\n* a `c:prepare/1` function which takes a set of options and initializes it, or disables the pipe.\n* a `c:call/2` function with the signature defined as in the function pipe.\n\nThe API expected by a module pipe is defined as a behaviour by this module.","ref":"erldns_pipeline.html#module-module-pipes"},{"type":"behaviour","title":"Configuration - erldns_pipeline","doc":"```erlang\n{erldns, [\n    {packet_pipeline, [\n        erldns_query_throttle,\n        erldns_packet_cache,\n        erldns_resolver,\n        erldns_packet_cache,\n        erldns_empty_verification\n    ]},\n]}\n```","ref":"erldns_pipeline.html#module-configuration"},{"type":"behaviour","title":"Examples - erldns_pipeline","doc":"Here's an example of a function pipe that arbitrarily sets the truncated bit\non a message if the query is directed to the \"example.com\" domain:\n\n```erlang\n-module(erldns_packet_pipe_example_set_truncated).\n-behaviour(erldns_pipeline).\n\n-export([prepare/1, call/2]).\n\n-spec prepare(erldns_pipeline:opts()) -> disabled | erldns_pipeline:opts().\nprepare(Opts) ->\n    case enabled() of\n        false -> disabled;\n        true -> Opts\n    end.\n\n-spec call(dns:message(), erldns_pipeline:opts()) -> erldns_pipeline:return().\ncall(#dns_message{questions = [#dns_query{name = <<\"example.com\">>} | _]} = Msg, _Opts) ->\n    Msg#dns_message{tc = true}.\ncall(Msg, _Opts) ->\n    Msg.\n```","ref":"erldns_pipeline.html#module-examples"},{"type":"callback","title":"erldns_pipeline.call/2","doc":"Trigger the pipeline at run-time.\n\nThis callback can return\n- a possibly new `t:dns:message/0`;\n- a tuple containing a new `t:dns:message/0` and a new set of `t:opts/0`;\n- a tuple `{stop, t:dns:message/0}` tuple to stop the pipeline execution altogether.","ref":"erldns_pipeline.html#c:call/2"},{"type":"function","title":"erldns_pipeline.call/2","doc":"","ref":"erldns_pipeline.html#call/2"},{"type":"type","title":"erldns_pipeline.host/0","doc":"The host that originated the request.","ref":"erldns_pipeline.html#t:host/0"},{"type":"type","title":"erldns_pipeline.opts/0","doc":"Options that can be passed and accumulated to the pipeline.","ref":"erldns_pipeline.html#t:opts/0"},{"type":"type","title":"erldns_pipeline.pipe/0","doc":"","ref":"erldns_pipeline.html#t:pipe/0"},{"type":"callback","title":"erldns_pipeline.prepare/1","doc":"Initialise the pipe handler, triggering side-effects and preparing any necessary metadata.\n\nThis will be called during the pipeline initialisation phase, which should happen at application\nstartup provided you added the pipeline to your application's supervision tree. This will be called\nonly once during application startup and therefore it is an opportunity to do any necessary\npreparations that can reduce the amount of work at runtime and therefore improve performance.\n\nThis callback can return `disabled`, and then the `c:call/2` callback won't be added to the\npipeline.","ref":"erldns_pipeline.html#c:prepare/1"},{"type":"type","title":"erldns_pipeline.return/0","doc":"","ref":"erldns_pipeline.html#t:return/0"},{"type":"type","title":"erldns_pipeline.transport/0","doc":"The underlying request transport protocol. All requests come either through UDP or TCP.","ref":"erldns_pipeline.html#t:transport/0"},{"type":"module","title":"erldns_query_throttle","doc":"Stateful query throttling. Currently only throttles `ANY` queries.\n\nWe should throttle `ANY` queries to discourage use of our authoritative name servers\nfor reflection/amplification attacks.","ref":"erldns_query_throttle.html"},{"type":"module","title":"Configuration - erldns_query_throttle","doc":"```erlang\n{erldns, [\n    {query_throttle, #{\n        enabled := boolean(), %% defaults to true\n        limit := non_neg_integer(), %% Number of queries to allow, defaults to 1\n        ttl := non_neg_integer(), %% Seconds, defaults to 30\n    }}\n]}\n```","ref":"erldns_query_throttle.html#module-configuration"},{"type":"module","title":"Telemetry events - erldns_query_throttle","doc":"- `[erldns, pipeline, throttle]` spans with `host` in the metadata\n    as triggered by `m:segmented_cache`.\n- `[erldns, pipeline, throttle]` with `host` in the metadata.","ref":"erldns_query_throttle.html#module-telemetry-events"},{"type":"function","title":"erldns_query_throttle.call/2","doc":"`c:erldns_pipeline:call/2` callback.","ref":"erldns_query_throttle.html#call/2"},{"type":"function","title":"erldns_query_throttle.clear/0","doc":"Clear the cache","ref":"erldns_query_throttle.html#clear/0"},{"type":"function","title":"erldns_query_throttle.prepare/1","doc":"`c:erldns_pipeline:prepare/1` callback.","ref":"erldns_query_throttle.html#prepare/1"},{"type":"module","title":"erldns_resolver","doc":"Resolve a DNS query.\n\nSupports only a single question per request: if a request contains multiple questions,\nonly the first question will be resolved.\n\nEmits the following telemetry events:\n- `[erldns, pipeline, resolver, error]` with `#{rc := dns:rcode/0}` metadata.","ref":"erldns_resolver.html"},{"type":"function","title":"erldns_resolver.best_match/2","doc":"","ref":"erldns_resolver.html#best_match/2"},{"type":"function","title":"erldns_resolver.best_match_at_node/1","doc":"","ref":"erldns_resolver.html#best_match_at_node/1"},{"type":"function","title":"erldns_resolver.call/2","doc":"`c:erldns_pipeline:call/2` callback.","ref":"erldns_resolver.html#call/2"},{"type":"function","title":"erldns_resolver.resolve/3","doc":"","ref":"erldns_resolver.html#resolve/3"},{"type":"module","title":"erldns_zone_cache","doc":"A cache holding all of the zone data.\n\nSupports only a single question per request: if a request contains multiple questions,\nonly the first question will be resolved.","ref":"erldns_zone_cache.html"},{"type":"function","title":"erldns_zone_cache.create/1","doc":"Creates a new table.","ref":"erldns_zone_cache.html#create/1"},{"type":"function","title":"erldns_zone_cache.delete_zone/1","doc":"Remove a zone from the cache without waiting for a response.","ref":"erldns_zone_cache.html#delete_zone/1"},{"type":"function","title":"erldns_zone_cache.delete_zone_rrset/5","doc":"Remove zone RRSet","ref":"erldns_zone_cache.html#delete_zone_rrset/5"},{"type":"function","title":"erldns_zone_cache.find_zone/1","doc":"Find a zone for a given qname.","ref":"erldns_zone_cache.html#find_zone/1"},{"type":"function","title":"erldns_zone_cache.find_zone/2","doc":"Find a zone for a given qname.","ref":"erldns_zone_cache.html#find_zone/2"},{"type":"function","title":"erldns_zone_cache.get_authority/1","doc":"Find the SOA record for the given DNS question or zone.","ref":"erldns_zone_cache.html#get_authority/1"},{"type":"function","title":"erldns_zone_cache.get_delegations/1","doc":"Get the list of NS and glue records for the given name.\n\nThis function will always return a list, even if it is empty.","ref":"erldns_zone_cache.html#get_delegations/1"},{"type":"function","title":"erldns_zone_cache.get_records_by_name/1","doc":"Return the record set for the given dname.","ref":"erldns_zone_cache.html#get_records_by_name/1"},{"type":"function","title":"erldns_zone_cache.get_records_by_name_and_type/2","doc":"Get all records for the given type and given name.","ref":"erldns_zone_cache.html#get_records_by_name_and_type/2"},{"type":"function","title":"erldns_zone_cache.get_rrset_sync_counter/3","doc":"Return current sync counter","ref":"erldns_zone_cache.html#get_rrset_sync_counter/3"},{"type":"function","title":"erldns_zone_cache.get_zone/1","doc":"Get a zone for the specific name.\n\nThis function will not attempt to resolve the dname in any way,\nit will simply look up the name in the underlying data store.","ref":"erldns_zone_cache.html#get_zone/1"},{"type":"function","title":"erldns_zone_cache.get_zone_records/1","doc":"Get all records for the given zone.","ref":"erldns_zone_cache.html#get_zone_records/1"},{"type":"function","title":"erldns_zone_cache.in_zone/1","doc":"Check if the name is in a zone.","ref":"erldns_zone_cache.html#in_zone/1"},{"type":"function","title":"erldns_zone_cache.put_zone/1","doc":"Put a name and its records into the cache, along with a SHA which can be\nused to determine if the zone requires updating.\n\nThis function will build the necessary Zone record before inserting.\n\nThe name of each record must be the fully qualified domain name (including the zone part).\n\nHere's an example:\n\n```erlang\nerldns_zone_cache:put_zone({\n  <<\"example.com\">>, <<\"someDigest\">>, [\n    #dns_rr{\n      name = <<\"example.com\">>,\n      type = ?DNS_TYPE_A,\n      ttl = 3600,\n      data = #dns_rrdata_a{ip = {1,2,3,4}}\n    },\n    #dns_rr{\n      name = <<\"www.example.com\">>,\n      type = ?DNS_TYPE_CNAME,\n      ttl = 3600,\n      data = #dns_rrdata_cname{dname = <<\"example.com\">>}\n    }\n  ]}).\n```","ref":"erldns_zone_cache.html#put_zone/1"},{"type":"function","title":"erldns_zone_cache.put_zone_rrset/4","doc":"Put zone RRSet","ref":"erldns_zone_cache.html#put_zone_rrset/4"},{"type":"function","title":"erldns_zone_cache.record_name_in_zone/2","doc":"Check if the record name is in the zone.\n\nWill also return true if a wildcard is present at the node.","ref":"erldns_zone_cache.html#record_name_in_zone/2"},{"type":"function","title":"erldns_zone_cache.update_zone_records_and_digest/3","doc":"Given a zone name, list of records, and a digest, update the zone metadata in cache.","ref":"erldns_zone_cache.html#update_zone_records_and_digest/3"},{"type":"function","title":"erldns_zone_cache.zone_names_and_versions/0","doc":"Return a list of tuples with each tuple as a name and the version SHA for the zone.","ref":"erldns_zone_cache.html#zone_names_and_versions/0"},{"type":"behaviour","title":"erldns_zone_codec","doc":"Encoding and decoding of zone data in JSON format.\n\nTo write custom codecs, you need to implement the callbacks exposed by this module,\nand register the codec in the configuration.","ref":"erldns_zone_codec.html"},{"type":"behaviour","title":"Configuration - erldns_zone_codec","doc":"```erlang\n{erldns, [\n    {zones, #{\n        codecs => [sample_custom_zone_codec]\n    }},\n]}\n```","ref":"erldns_zone_codec.html#module-configuration"},{"type":"behaviour","title":"Custom codecs - erldns_zone_codec","doc":"```erlang\n-module(sample_custom_zone_codec).\n-behaviour(erldns_zone_codec).\n\n-include_lib(\"dns_erlang/include/dns.hrl\").\n-include_lib(\"erldns/include/erldns.hrl\").\n\n-export([decode/1, encode/1]).\n\n-define(DNS_TYPE_SAMPLE, 40000).\n\ndecode(#{~\"name\" := Name, ~\"type\" := ~\"SAMPLE\", ~\"ttl\" := Ttl, ~\"data\" := Data}) ->\n    #dns_rr{\n        name = Name,\n        type = ?DNS_TYPE_SAMPLE,\n        data = maps:get(~\"dname\", Data),\n        ttl = Ttl\n    };\ndecode(_) ->\n    not_implemented.\n\nencode(#dns_rr{name = Name, type = ?DNS_TYPE_SAMPLE, ttl = Ttl, data = Data}) ->\n    #{\n        ~\"name\" => Name,\n        ~\"type\" => ~\"SAMPLE\",\n        ~\"ttl\" => Ttl,\n        ~\"content\" => erlang:iolist_to_binary(io_lib:format(\"~s\", [Data]))\n    };\nencode(_) ->\n    not_implemented.\n```","ref":"erldns_zone_codec.html#module-custom-codecs"},{"type":"function","title":"erldns_zone_codec.build_zone/4","doc":"","ref":"erldns_zone_codec.html#build_zone/4"},{"type":"callback","title":"erldns_zone_codec.decode/1","doc":"","ref":"erldns_zone_codec.html#c:decode/1"},{"type":"function","title":"erldns_zone_codec.decode/1","doc":"Takes a JSON map and turns it into a zone.","ref":"erldns_zone_codec.html#decode/1"},{"type":"type","title":"erldns_zone_codec.decoder/0","doc":"","ref":"erldns_zone_codec.html#t:decoder/0"},{"type":"callback","title":"erldns_zone_codec.encode/1","doc":"","ref":"erldns_zone_codec.html#c:encode/1"},{"type":"function","title":"erldns_zone_codec.encode/1","doc":"Equivalent to  encode(Zone, #{mode => zone_to_json}) .","ref":"erldns_zone_codec.html#encode/1"},{"type":"function","title":"erldns_zone_codec.encode/2","doc":"Takes a zone and turns it into a map.","ref":"erldns_zone_codec.html#encode/2"},{"type":"type","title":"erldns_zone_codec.encoder/0","doc":"","ref":"erldns_zone_codec.html#t:encoder/0"},{"type":"function","title":"erldns_zone_codec.list_codecs/0","doc":"Get the list of registered zone parsers.","ref":"erldns_zone_codec.html#list_codecs/0"},{"type":"function","title":"erldns_zone_codec.register_codec/1","doc":"Register a custom parser module.","ref":"erldns_zone_codec.html#register_codec/1"},{"type":"function","title":"erldns_zone_codec.register_codecs/1","doc":"Register a list of custom parser modules.","ref":"erldns_zone_codec.html#register_codecs/1"},{"type":"module","title":"erldns_zone_loader","doc":"Functions for loading zones from local or remote sources.","ref":"erldns_zone_loader.html"},{"type":"module","title":"Configuration - erldns_zone_loader","doc":"```erlang\n{erldns, [\n    {zones, #{\n        path => \"zones.json\",\n        strict => true\n    }\n]}\n```\nSee the type `t:erldns_zones:config/0` for details.","ref":"erldns_zone_loader.html#module-configuration"},{"type":"function","title":"erldns_zone_loader.load_zones/0","doc":"Load zones.","ref":"erldns_zone_loader.html#load_zones/0"},{"type":"function","title":"erldns_zone_loader.load_zones/1","doc":"Load zones from a file in strict or loose mode.","ref":"erldns_zone_loader.html#load_zones/1"},{"type":"module","title":"erldns_zones","doc":"The system responsible for loading and caching zone data.\n\nZones are loaded by default from JSON files in the `priv/zones/` directory.\nThe path is configured in `erldns.config` using the `zones.path` setting.\n\nFor more details about zone file format and configuration, see [`ZONES`](priv/zones/ZONES.md).\n\nFor more details about its subsections, see:\n- `m:erldns_zone_cache`\n- `m:erldns_zone_codec`\n- `m:erldns_zone_loader`","ref":"erldns_zones.html"},{"type":"module","title":"Configuration - erldns_zones","doc":"```erlang\n{erldns, [\n    {zones, #{\n        path => \"zones.json\",\n        strict => true,\n        codecs => [sample_custom_zone_codec]\n    }},\n]}\n```\n\nSee the type `t:config/0` for details.","ref":"erldns_zones.html#module-configuration"},{"type":"type","title":"erldns_zones.config/0","doc":"Zone configuration.\n\nPath can be a directory, and `strict` declares whether load failure should crash or be ignored.\nIf a path is configured and `strict` is true, and the path is not resolvable, it will fail.\nSee `m:erldns_zone_loader` for more details.\n\nCodecs are a list of modules that implement the `m:erldns_zone_codec` behaviour.","ref":"erldns_zones.html#t:config/0"},{"type":"module","title":"erldns_listeners","doc":"DNS listeners configuration.\n\nIn order to configure, add to the application environment:\n\n```erlang\n{erldns, [\n    {listeners, [\n        #{name => Name, transport => Protocol, ip => IP, port => Port, parallel_factor => PFactor}\n    ]}\n]}\n```\nSee the type `t:config/0` for details.","ref":"erldns_listeners.html"},{"type":"module","title":"Telemetry events - erldns_listeners","doc":"Emits the following telemetry events:\n\n### `[erldns, request, start]`\n- Measurements:\n```erlang\nmonotonic_time := integer()\nrequest_size := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\n```\n\n### `[erldns, request, stop]`\n- Measurements:\n```erlang\nmonotonic_time := integer()\nduration := non_neg_integer()\nresponse_size := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\ndnssec := boolean()\n```\n\n### `[erldns, request, error]`\n- Measurements:\n```erlang\ncount := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\nkind => exit | error | throw\nreason => term()\nstacktrace => [term()]\n```\n\n### `[erldns, request, timeout]`\n- Measurements:\n```erlang\ncount := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\n```\n\n### `[erldns, request, dropped]`\n- Measurements:\n```erlang\ncount := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\n```\n\n### `[erldns, request, delayed]`\n- Measurements:\n```erlang\ncount := non_neg_integer()\n```\n- Metadata:\n```erlang\ntransport := udp | tcp\n```","ref":"erldns_listeners.html#module-telemetry-events"},{"type":"type","title":"erldns_listeners.config/0","doc":"Configuration map for a listener.\n\nIt can contain the following keys:\n- `Name` is any desired name in the form of an atom,\n- `IP` is `any`, in which case it will listen on all interfaces,\n    or a valid ip address in tuple or string format. Default is `any`.\n- `Port` is a valid port number. Default is `53`.\n- `Protocol` is either `tcp` or `udp`, or `both`. Default is `both`.","ref":"erldns_listeners.html#t:config/0"},{"type":"function","title":"erldns_listeners.get_stats/0","doc":"Get statistics about all listeners.","ref":"erldns_listeners.html#get_stats/0"},{"type":"type","title":"erldns_listeners.name/0","doc":"Name of the listener, a required parameter.","ref":"erldns_listeners.html#t:name/0"},{"type":"type","title":"erldns_listeners.parallel_factor/0","doc":"A multiplying factor for parallelisation.\n\nThe number of schedulers is multiplied by this factor when creating worker pools.\nBy default, it is `1`. The number of TCP and UDP acceptors will be of this size,\nwhile the number of UDP workers will be 4x and the maximum number of TCP workers will be 1024x.\nNote that the UDP pool is static, while the TCP pool is dynamic.\nSee `m:wpool` and `m:ranch` respectively for details.","ref":"erldns_listeners.html#t:parallel_factor/0"},{"type":"function","title":"erldns_listeners.reset_queues/0","doc":"Reset all queues by restarting all listeners.","ref":"erldns_listeners.html#reset_queues/0"},{"type":"type","title":"erldns_listeners.stats/0","doc":"Statistics about each listener.","ref":"erldns_listeners.html#t:stats/0"},{"type":"type","title":"erldns_listeners.transport/0","doc":"TCP or UDP, or both. Default is `both`","ref":"erldns_listeners.html#t:transport/0"},{"type":"extras","title":"Erlang DNS Server","doc":"# Erlang DNS Server\n\nServe DNS authoritative responses... with Erlang.\n\n[![Erlang/OTP Versions](https://img.shields.io/badge/erlang%2Fotp-27%7C28-blue)](https://www.erlang.org)\n[![Build Status](https://github.com/dnsimple/erldns/actions/workflows/ci.yml/badge.svg)](https://github.com/dnsimple/erldns/actions/workflows/ci.yml)\n[![Module Version](https://img.shields.io/hexpm/v/erldns.svg)](https://hex.pm/packages/erldns)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/erldns/)\n[![Hex Downloads](https://img.shields.io/hexpm/dt/erldns.svg)](https://hex.pm/packages/erldns)\n[![Coverage Status](https://coveralls.io/repos/github/dnsimple/erldns/badge.svg?branch=main)](https://coveralls.io/github/dnsimple/erldns?branch=main)\n\nThis application consists of three main subsystems:\n\n- `m:erldns_zones`\nThe system responsible for loading and caching zone data.\n\n- `m:erldns_pipeline`\nThe system responsible for processing incoming DNS queries.\n\n- `m:erldns_listeners`\nThe system responsible for listening for incoming DNS queries. The system is designed to be able to listen on multiple ports and interfaces and supports both UDP and TCP, Unix network stack optimisations, and high parallelism.\n\nThere is also an administrative API for querying the current zone cache and for basic control.\nYou can read more about it at `m:erldns_admin`.","ref":"readme.html"},{"type":"extras","title":"Instrumentation - Erlang DNS Server","doc":"[Telemetry](https://hex.pm/packages/telemetry) is used to instrument the code.\n\nAll events are divided in the following namespaces:\n\n- `[erldns, pipeline | _]` are triggered by the `m:erldns_pipeline` subsystem.\n- `[erldns, request | _]` are triggered by the `m:erldns_listeners` subsystem.","ref":"readme.html#instrumentation"},{"type":"extras","title":"Getting started - Erlang DNS Server","doc":"You can use this application as a standalone service or embedded into your OTP application. In both\ncases, you'll need to: configure it, and load zones.","ref":"readme.html#getting-started"},{"type":"extras","title":"Zones - Erlang DNS Server","doc":"Zones are loaded from JSON files in the `priv/zones/` directory. The path is configured in `erldns.config` using the `zones.path` setting. For more details about zone file format and configuration, see [`priv/zones/ZONES`](priv/zones/ZONES.md).","ref":"readme.html#zones"},{"type":"extras","title":"Configuration - Erlang DNS Server","doc":"An example configuration file can be found in `erldns.example.config`. For more details, see the\nsubsystems and the admin API documentation.\n\nTo get started, copy it into your own `erldns.config` and modify as needed.","ref":"readme.html#configuration"},{"type":"extras","title":"Building - Erlang DNS Server","doc":"To build:\n\n```sh\nmake\n```\n\nTo start fresh:\n\n```sh\nmake fresh\nmake\n```","ref":"readme.html#building"},{"type":"extras","title":"Running - Erlang DNS Server","doc":"","ref":"readme.html#running"},{"type":"extras","title":"Launch directly - Erlang DNS Server","doc":"```sh\novermind start\n```","ref":"readme.html#launch-directly"},{"type":"extras","title":"To get an interactive Erlang REPL - Erlang DNS Server","doc":"```sh\nrebar3 shell\n```","ref":"readme.html#to-get-an-interactive-erlang-repl"},{"type":"extras","title":"Build a distribution with and run the release - Erlang DNS Server","doc":"```sh\nrebar3 release\n_build/default/rel/erldns/bin/erldns foreground\n```","ref":"readme.html#build-a-distribution-with-and-run-the-release"},{"type":"extras","title":"Querying - Erlang DNS Server","doc":"Here are some queries to try:\n\n```sh\ndig -p 8053 @127.0.0.1 example.com a\ndig -p 8053 @127.0.0.1 example.com cname\ndig -p 8053 @127.0.0.1 example.com ns\ndig -p 8053 @127.0.0.1 example.com mx\ndig -p 8053 @127.0.0.1 example.com spf\ndig -p 8053 @127.0.0.1 example.com txt\ndig -p 8053 @127.0.0.1 example.com sshfp\ndig -p 8053 @127.0.0.1 example.com soa\ndig -p 8053 @127.0.0.1 example.com naptr\ndig -p 8053 @127.0.0.1 -x 127.0.0.1 ptr\n```","ref":"readme.html#querying"},{"type":"extras","title":"Performance - Erlang DNS Server","doc":"If you want to perform some benchmarks, see [`benchmarking`](./BENCHMARKING.md).","ref":"readme.html#performance"},{"type":"extras","title":"AXFR Support - Erlang DNS Server","doc":"AXFR zone transfers are not currently implemented. The current \"implementation\" is just a stub.","ref":"readme.html#axfr-support"},{"type":"extras","title":"Tests - Erlang DNS Server","doc":"To run automated tests:\n\n```sh\nmake test\n```\n\nThis runs the following:\n\n- [erlfmt](https://hex.pm/packages/erlfmt)\n- [Elvis linter](https://hex.pm/packages/elvis_core)\n- [xref](https://www.erlang.org/doc/apps/tools/xref.html)\n- [dialyzer](https://www.erlang.org/doc/apps/dialyzer/dialyzer.html)\n- [ExDoc](https://hexdocs.pm/ex_doc/readme.html)\n- [EUnit](https://www.erlang.org/doc/apps/eunit/chapter.html)\n- [Common Tests](https://www.erlang.org/doc/apps/common_test/ct.html)\n- [Coverage](https://www.erlang.org/doc/apps/tools/cover.html)","ref":"readme.html#tests"},{"type":"extras","title":"Zones","doc":"# Zones\n\nerldns reads zone files from this folder, and loads them on start. Zones must be formatted as JSON, and stored in `.json` files.","ref":"zones.html"},{"type":"extras","title":"Default zones - Zones","doc":"All `.json` files within this folder are default zones, packaged with the default `erldns` distribution. They are used to bootstrap the state when you start the project.","ref":"zones.html#default-zones"},{"type":"extras","title":"Custom zones - Zones","doc":"You can place your custom zones files inside the `priv/zones/local` directory. The content of this folder is not tracked by version control, and you can use it freely to add more zones for any purpose.","ref":"zones.html#custom-zones"},{"type":"extras","title":"JSON files - Zones","doc":"A JSON zone file contains an array of 1 or more zones. Each zone has a name and an array of records. Each record has a name, type, ttl and data field. The data field contains a JSON object with one or more attributes that are appropriate for the specific record type.","ref":"zones.html#json-files"},{"type":"extras","title":"Example - Zones","doc":"The follow is an example of a collection of zones with a single zone in the collection:\n\n```json\n[\n  {\n    \"name\": \"example.com\",\n    \"records\": [\n      {\n        \"name\": \"example.com\",\n        \"type\": \"SOA\",\n        \"ttl\": 3600,\n        \"data\": {\n          \"mname\": \"ns1.example.com\",\n          \"rname\": \"admin.example.com\",\n          \"serial\": 1234567,\n          \"refresh\": 1,\n          \"retry\": 1,\n          \"expire\": 1,\n          \"minimum\": 1\n        }\n      },\n      {\n        \"name\": \"example.com\",\n        \"type\": \"A\",\n        \"ttl\": 3600,\n        \"data\": {\n          \"ip\": \"1.2.3.4\"\n        }\n      },\n      {\n        \"name\": \"example.com\",\n        \"type\": \"MX\",\n        \"ttl\": 3600,\n        \"data\": {\n          \"preference\": 10,\n          \"exchange\": \"mail.example.com\"\n        }\n      }\n    ]\n  }\n]\n```","ref":"zones.html#example"},{"type":"extras","title":"Design Decisions","doc":"# Design Decisions\n\nThis document captures key architectural decisions made in the `erldns` project. Each section follows a \"what and why\" structure, first describing the technical implementation details and then explaining the rationale behind these choices. This approach helps maintain a clear record of our design decisions and their motivations for future reference.","ref":"design.html"},{"type":"extras","title":"UDP Payload Size Handling - Design Decisions","doc":"DNS over UDP has traditionally been limited to 512 bytes per message. However, with the introduction of EDNS (Extension Mechanisms for DNS), clients can specify larger UDP payload sizes through the OPT RR (Resource Record) in the additional section of the DNS message.\n\nIn Erldns, we've implemented a strict enforcement of UDP payload sizes to ensure compatibility and prevent potential issues:\n\n1. **Minimum Size**: We enforce a minimum UDP payload size of 512 bytes (`?MIN_PACKET_SIZE`), which is the traditional DNS UDP message size limit.\n2. **Maximum Size**: We enforce a maximum UDP payload size of 1232 bytes (`?MAX_PACKET_SIZE`), which is the recommended maximum size for DNS over UDP to avoid IP fragmentation.\n3. **Payload Size Adjustment**: When a client sends a DNS request with an OPT RR containing an invalid UDP payload size (either too small or too large), we automatically adjust it to the maximum allowed size (1232 bytes) rather than rejecting the request.\n\nThis design decision prioritizes graceful degradation by automatically adjusting invalid payload sizes rather than rejecting requests, while simultaneously protecting against potential DoS attacks through oversized packets.","ref":"design.html#udp-payload-size-handling"},{"type":"extras","title":"Contributing to erldns","doc":"# Contributing to erldns","ref":"contributing.html"},{"type":"extras","title":"Getting started - Contributing to erldns","doc":"","ref":"contributing.html#getting-started"},{"type":"extras","title":"1. Clone the repository - Contributing to erldns","doc":"Clone the repository and move into it:\n\n```shell\ngit clone git@github.com:dnsimple/erldns.git\ncd erldns\n```","ref":"contributing.html#1-clone-the-repository"},{"type":"extras","title":"2. Install Erlang - Contributing to erldns","doc":"","ref":"contributing.html#2-install-erlang"},{"type":"extras","title":"3. Install the dependencies - Contributing to erldns","doc":"```shell\nmake\n```\n\n#### Updating Dependencies\n\nWhen dependencies are updated the rebar.lock file will need to be updated for the new dependency to be used. The following command does this:\n\n```shell\nrebar3 upgrade --all\n```","ref":"contributing.html#3-install-the-dependencies"},{"type":"extras","title":"Formatting - Contributing to erldns","doc":"If your editor doesn't automatically format Erlang code using [erlfmt](https://github.com/WhatsApp/erlfmt), run:\n\n```shell\nmake format\n```\n\nYou should run this command before releasing.","ref":"contributing.html#formatting"},{"type":"extras","title":"3. Build and test - Contributing to erldns","doc":"Compile the project and [run the test suite](#testing) to check everything works as expected.","ref":"contributing.html#3-build-and-test"},{"type":"extras","title":"Testing - Contributing to erldns","doc":"```shell\nmake test\n```","ref":"contributing.html#testing"},{"type":"extras","title":"Releasing - Contributing to erldns","doc":"The following instructions uses `$VERSION` as a placeholder, where `$VERSION` is a `MAJOR.MINOR.BUGFIX` release such as `1.2.0`.\n\n1. Run the test suite and ensure all the tests pass.\n\n1. Finalize the `","ref":"contributing.html#releasing"},{"type":"extras","title":"mainsection inCHANGELOG.md` assigning the version. - Contributing to erldns","doc":"1. Commit and push the changes\n\n    ```shell\n    git commit -a -m \"Release $VERSION\"\n    git push origin main\n    ```\n\n1. Wait for CI to complete.\n\n1. Create a signed tag.\n\n    ```shell\n    git tag -a v$VERSION -s -m \"Release $VERSION\"\n    git push origin --tags\n    ```\n\n1. GitHub actions will take it from there and release to","ref":"contributing.html#mainsection-inchangelog-md-assigning-the-version"},{"type":"extras","title":"Tests - Contributing to erldns","doc":"Submit unit tests for your changes. You can test your changes on your machine by [running the test suite](#testing).\n\nWhen you submit a PR, tests will also be run on the [continuous integration environment via GitHub Actions](https://github.com/dnsimple/erldns/actions/workflows/ci.yml).","ref":"contributing.html#tests"},{"type":"extras","title":"Benchmarking","doc":"# Benchmarking\n\nThis guide contains some information on how to benchmark `erldns` locally.","ref":"benchmarking.html"},{"type":"extras","title":"Install dnsperf - Benchmarking","doc":"The recommended benchmarking tool is [`dnsperf`](https://github.com/DNS-OARC/dnsperf). You can compile it from source or, if on macOS, install it with:\n\n```shell\nbrew install dnsperf\n```","ref":"benchmarking.html#install-dnsperf"},{"type":"extras","title":"Create a Queries File - Benchmarking","doc":"`dnsperf` requires DNS queries to run in order to perform benchmarks. You can use whatever queries to test different aspects of `erldns`, such as how it behaves when mostly responding to unknown records or when you execute the same query many times in a row.\n\nA good start is a small file with some `example.com`-related queries, as `example.com` domains are the default in [the sample config file](./erldns.example.config).\n\nPut this in `queries.txt`:\n\n```text\nthumbs2.ebaystatic.com. AAAA\nsip.hotmail.com. A\ngoogle.com. A\ncache.defamer.com. A\nexample.com. A\nwww.example.com. CNAME\n```","ref":"benchmarking.html#create-a-queries-file"},{"type":"extras","title":"Start the Server - Benchmarking","doc":">","ref":"benchmarking.html#start-the-server"},{"type":"extras","title":"Important - Benchmarking","doc":">\n> Start `erldns` as a release to make sure it gets compiled with production-like settings, rather than dev settings (as in `rebar3 shell`).\n\nFirst, create a release:\n\n```shell\nrebar3 release\n```\n\nThen, start the release in the foreground:\n\n```shell\n./_build/default/rel/erldns/bin/erldns foreground\n```","ref":"benchmarking.html#important"},{"type":"extras","title":"Run the Benchmark - Benchmarking","doc":"Now you're ready to run benchmarks. For example:\n\n```shell\ndnsperf -p 8053 -d ./queries.txt -T 4 -c 20 -n 10000\n```\n\nSee `dnsperf -h` for an explanation of the flags.","ref":"benchmarking.html#run-the-benchmark"},{"type":"extras","title":"Latest Benchmark - Benchmarking","doc":"The latest benchmark was run on 2025/06/06 by @nelsonvides, on an 2023 Apple MacBook Pro, 16-inch, M3 Pro CPU, 36GB of memory.\n\nIn these conditions, `erldns` can serve around 85k QPS, in a mix of resolvable and\nnon-authoritative cases; and around 71k QPS when all queries are resolvable\nThe details of the benchmark are below.","ref":"benchmarking.html#latest-benchmark"},{"type":"extras","title":"A mix of resolvable and non-authoritative - Benchmarking","doc":"With this query file:\n\n```text\nthumbs2.ebaystatic.com. AAAA\nsip.hotmail.com. A\ngoogle.com. A\ncache.defamer.com. A\nexample.com. A\nwww.example.com. CNAME\n```\n\nThe results are as follows:\n\n```text\nDNS Performance Testing Tool\nVersion 2.14.0\n\n[Status] Command line: dnsperf -p 8053 -d ./queries.txt -T 6 -c 256 -l 30\n[Status] Sending queries (to 127.0.0.1:8053)\n[Status] Started at: Fri Jun  6 20:49:49 2025\n[Status] Stopping after 30.000000 seconds\n[Status] Testing complete (time limit)\n\nStatistics:\n\n  Queries sent:         2558497\n  Queries completed:    2558497 (100.00%)\n  Queries lost:         0 (0.00%)\n\n  Response codes:       NOERROR 852832 (33.33%), REFUSED 1705665 (66.67%)\n  Average packet size:  request 33, response 43\n  Run time (s):         30.000527\n  Queries per second:   85281.735218\n\n  Average Latency (s):  0.000934 (min 0.000039, max 0.022900)\n  Latency StdDev (s):   0.000513\n```\n\n\n#### All resolvable\n\nWith this query file:\n\n```text\nexample.com A\nexample.com NS\nexample.com AAAA\nexample.com CAA\nexample.com CNAME\nldap.example.com A\nns2.test.com A\nwww.test.com CNAME\n```\n\nThe results are as follows:\n\n```text\nDNS Performance Testing Tool\nVersion 2.14.0\n\n[Status] Command line: dnsperf -p 8053 -d ./queries.txt -T 6 -c 256 -l 30\n[Status] Sending queries (to 127.0.0.1:8053)\n[Status] Started at: Fri Jun  6 20:47:56 2025\n[Status] Stopping after 30.000000 seconds\n[Status] Testing complete (time limit)\n\nStatistics:\n\n  Queries sent:         2143197\n  Queries completed:    2143197 (100.00%)\n  Queries lost:         0 (0.00%)\n\n  Response codes:       NOERROR 1875298 (87.50%), NXDOMAIN 267899 (12.50%)\n  Average packet size:  request 29, response 74\n  Run time (s):         30.001319\n  Queries per second:   71436.759164\n\n  Average Latency (s):  0.001183 (min 0.000035, max 0.057426)\n  Latency StdDev (s):   0.001117\n```","ref":"benchmarking.html#a-mix-of-resolvable-and-non-authoritative"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.1.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html"},{"type":"extras","title":"main - Changelog","doc":"This is a big release full of massive performance improvements and protocol compliance,\nbut also of breaking changes. Read carefully the changelog and the documentation before migrating.","ref":"changelog.html#main"},{"type":"extras","title":"Changed - Changelog","doc":"The application is now divided in three core subsystems, that is, _listeners_, _packet pipelines_,\nand _zones_, which are configured differently and will require migration.\nSee `m:erldns_listeners`. `m:erldns_pipeline` and `m:erldns_zones` respectively for documentation\non how to reconfigure.\n\nTelemetry events, as well as logger events, are entirely scoped within these respective subsystems,\nthat means, that the events are now prefixed with `[erldns, request, _]`, for listener workers,\nand `[erldns, pipeline]` for pipeline processing. Similarly, logger events are tagged with\n`domain => [erldns, admin | listeners | pipeline | zones]` metadata, and all are structured.\n\n#### Custom parsers and encoders\n\nIf you had any custom parser or encoder, you will need to update them to the new API, which unifies\nboth into a single module. See `m:erldns_zone_codec` for more information on its callbacks. Note\nthat the `zone_to_erlang/1,2` callbacks are now `decode/1` and `zone_*/x` callbacks are now\n`encode/2`, and they all take only maps as input and output respectively.\n\n#### TXT and SPF record formats\n\nTXT and SPF record formats has changed, from a single string, to an array, to support\nmore complex DNS records & use cases, so that the following:\n\n```json\n{\n  ...\n  \"type\": \"TXT\",\n  \"data\": {\n    \"txt\": \"\\\"Hi, this is some text\\\" \\\"with extras\\\"\"\n  }\n},\n```\n\nbecomes\n\n```json\n{\n  ...\n  \"type\": \"TXT\",\n  \"data\": {\n    \"txts\": [\"Hi, this is some text\", \"with extras\"]\n  }\n},\n```\n\nA warning will be logged for each invalid record, but they will be skipped, and not loaded.","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Support for OTP28 [#220](https://github.com/dnsimple/erldns/pull/220)\n- Support for `dns_erlang` v4, which enforces strings as binaries and options as maps\n- Introduce domain tag in logger events [#244](https://github.com/dnsimple/erldns/pull/244)","ref":"changelog.html#added"},{"type":"extras","title":"Removed - Changelog","doc":"- Support for TXT and SPF records with data as a single string, they must be a list of strings instead.\n- Support for the `erldns_txt` parser [#248](https://github.com/dnsimple/erldns/pull/248)\n- Support for zone parsers taking input as lists [#231](https://github.com/dnsimple/erldns/pull/231)","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix DNSSEC timestamps [#234](https://github.com/dnsimple/erldns/pull/234)\n- Fix (C)DNS/(C)DNSKEY signing [#235](https://github.com/dnsimple/erldns/pull/235)","ref":"changelog.html#fixed"},{"type":"extras","title":"Security - Changelog","doc":"- Remove support for the `erldns_txt` parser. [#248](https://github.com/dnsimple/erldns/pull/248)\n- Backpressure mechanisms to survive DDoS attacks [#240](https://github.com/dnsimple/erldns/pull/240)","ref":"changelog.html#security"},{"type":"extras","title":"7.0.0-rc9 - Changelog","doc":"- Remove support for the `erldns_txt` parser. [#248](https://github.com/dnsimple/erldns/pull/248)\n- Introduce backpressure and load shedding [#240](https://github.com/dnsimple/erldns/pull/240)\n- Introduce domain tag in logger events [#244](https://github.com/dnsimple/erldns/pull/244)","ref":"changelog.html#7-0-0-rc9"},{"type":"extras","title":"7.0.0-rc8 - Changelog","doc":"- zone cache `put_rrset_zone` accepts zone records [#243](https://github.com/dnsimple/erldns/pull/243)","ref":"changelog.html#7-0-0-rc8"},{"type":"extras","title":"7.0.0-rc7 - Changelog","doc":"- Fix overriding packet size in optrr record [#242](https://github.com/dnsimple/erldns/pull/242)","ref":"changelog.html#7-0-0-rc7"},{"type":"extras","title":"7.0.0-rc6 - Changelog","doc":"- Fix cache non-normalised match bug [#241](https://github.com/dnsimple/erldns/pull/241)","ref":"changelog.html#7-0-0-rc6"},{"type":"extras","title":"7.0.0-rc5 - Changelog","doc":"- Rework zones loader [#230](https://github.com/dnsimple/erldns/pull/230)\n- Rework zones codecs [#231](https://github.com/dnsimple/erldns/pull/231)\n- Rework zones cache [#232](https://github.com/dnsimple/erldns/pull/232)\n- Rework documentation and internals [#233](https://github.com/dnsimple/erldns/pull/233)\n- Fix (C)DNS/(C)DNSKEY signing [#235](https://github.com/dnsimple/erldns/pull/235)","ref":"changelog.html#7-0-0-rc5"},{"type":"extras","title":"7.0.0-rc4 - Changelog","doc":"- Fix DNSSEC timestamps [#234](https://github.com/dnsimple/erldns/pull/234)","ref":"changelog.html#7-0-0-rc4"},{"type":"extras","title":"7.0.0-rc3 - Changelog","doc":"- Add statistic functionality to listeners [#227](https://github.com/dnsimple/erldns/pull/227)","ref":"changelog.html#7-0-0-rc3"},{"type":"extras","title":"7.0.0-rc2 - Changelog","doc":"- Refactor the query processing pipeline [#224](https://github.com/dnsimple/erldns/pull/224)\n- Reimplement the network stack [#225](https://github.com/dnsimple/erldns/pull/225)","ref":"changelog.html#7-0-0-rc2"},{"type":"extras","title":"7.0.0-rc1 - Changelog","doc":"- Upgrade `dns_erlang` to v4.\n- Use `segmented_cache` for the zone cache and the throttle modules.","ref":"changelog.html#7-0-0-rc1"},{"type":"extras","title":"6.0.2 - Changelog","doc":"- Add mailbox length telemetry events.\n- Keep the handlers state in an ets table and avoid the singleton gen_server call.","ref":"changelog.html#6-0-2"},{"type":"extras","title":"6.0.1 - Changelog","doc":"- Add terminating context to telemetry span events","ref":"changelog.html#6-0-1"},{"type":"extras","title":"6.0.0 - Changelog","doc":"- Instrument code using telemetry in a metrics agnostic way.","ref":"changelog.html#6-0-0"},{"type":"extras","title":"5.0.0 - Changelog","doc":"- Introduce support for Logger\n- Remove lager\n- Remove the `erldns_events` singleton.","ref":"changelog.html#5-0-0"},{"type":"extras","title":"4.3.1 - Changelog","doc":"- Export dnssec internal new API endpoint","ref":"changelog.html#4-3-1"},{"type":"extras","title":"4.3.0 - Changelog","doc":"- Add support for NSEC compact denial of existence","ref":"changelog.html#4-3-0"},{"type":"extras","title":"4.2.4 - Changelog","doc":"- Add support for zone records directory loading\n- Add the latest `dnstest` version fixing almost all tests","ref":"changelog.html#4-2-4"},{"type":"extras","title":"4.2.3 - Changelog","doc":"- Update `dns_erlang`: fix EDNS0 compliance for truncated records and unsupported versions","ref":"changelog.html#4-2-3"},{"type":"extras","title":"4.2.2 - Changelog","doc":"- Test admin API and fix bugs related to authentication and json encoding","ref":"changelog.html#4-2-2"},{"type":"extras","title":"4.2.1 - Changelog","doc":"- Ensure supervision tree starts correctly","ref":"changelog.html#4-2-1"},{"type":"extras","title":"4.2.0 - Changelog","doc":"- Merge admin and metrics APIs into this repository.","ref":"changelog.html#4-2-0"},{"type":"extras","title":"4.1.2 - Changelog","doc":"- Hide SPF/TXT multipart handling behind a feature flag\n- Fix a bug mixing SPF and TXT records","ref":"changelog.html#4-1-2"},{"type":"extras","title":"4.1.1 - Changelog","doc":"- Bugfix handling null in the zone parser json payloads","ref":"changelog.html#4-1-1"},{"type":"extras","title":"4.1.0 - Changelog","doc":"- Introduce SPF/TXT multipart handling (#150)","ref":"changelog.html#4-1-0"},{"type":"extras","title":"4.0.0 - Changelog","doc":"- Add ex_doc support\n- Remove support for OpenTelemetry.","ref":"changelog.html#4-0-0"},{"type":"extras","title":"3.0.0 - Changelog","doc":"","ref":"changelog.html#3-0-0"},{"type":"extras","title":"Changed - Changelog","doc":"- Bumps to OTP/27\n- Replaced \"jsx\" with \"json\"\n- Bumps to [dns_erlang/v2.0.0](https://hex.pm/packages/dns_erlang/2.0.0)","ref":"changelog.html#changed-1"},{"type":"extras","title":"Added - Changelog","doc":"- erlfmt\n- CONTRIBUTING.md\n- CHANGELOG.md\n- release process to hex.pm","ref":"changelog.html#added-1"},{"type":"extras","title":"2.2.0 - Changelog","doc":"- ...","ref":"changelog.html#2-2-0"},{"type":"extras","title":"Copyright (c) 2012-2025 DNSimple Corporation","doc":"# Copyright (c) 2012-2025 DNSimple Corporation\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}